import React, {useEffect, useState} from "react";
import treemap from './macrofocus-treemap';
// import kotlin from "kotlin";
import './Demo.css';

function Demo() {
    const [model, setModel] = useState(null)

    useEffect(() => {
        const response = fetch('https://public.treemap.com/rest/json/Forbes%20Global%202000%20-%202021.mtm');
        const json = response.then(response => response.text()).then(json => {
                var jsonDataFrame = treemap.org.molap.dataframe.JsonDataFrame.fromString(json)
                var dataFrame = new treemap.org.molap.dataframe.DefaultDataFrame(jsonDataFrame)

                let treeMapModel = new treemap.com.treemap.DefaultTreeMapModel(dataFrame);

                var settings = treeMapModel.settings

                // General
                // settings.rendering = treemap.com.treemap.RenderingFactory.FLAT
                settings.rendering = new treemap.com.treemap.FlatRendering()

                // Group by
                settings.groupByColumns = new treemap.com.macrofocus.common.collection.JsArrayList(["Sector", "Industry"])

                // Size
                settings.sizeColumn = "Market Value"

                // Color
                settings.colorColumn = "Profits"
                var profitsSettings = settings.getColumnSettings("Profits")
                var negpos = new treemap.org.mkui.palette.PaletteFactory().getPalette("negpos")
                // var negpos = treemap.org.mkui.palette.PaletteFactory.Companion.instance.getPalette("negpos")
                var colorMap = treeMapModel.getColorMap("Profits")
                colorMap.palette = negpos
                colorMap.interval.setValue(-63.93, 127.86)

                // Label
                var companySettings = settings.getColumnSettings("Company")
                // companySettings.setLabelingFont(CPFont("Helvetica", 9.0)) // 9 points is the minimum size that will be displayed
                companySettings.setLabelingMinimumCharactersToDisplay(5)
                companySettings.setLabelingResizeTextToFitShape(true)
                // companySettings.setLabelingVerticalAlignment(EnhancedLabel.CENTER)
                // companySettings.setLabelingHorizontalAlignment(EnhancedLabel.CENTER)

                setModel(treeMapModel)
            }
        )
    }, [])

    return (
        <div className="Demo">
            <treemap.com.treemap.TreeMapRComponent model={model}/>
        </div>
    );
}

export default Demo;
